<%@ page contentType="text/html; charset=utf-8" %>
<%@ page pageEncoding="utf-8" import="cviceni6.*" %>
<%@ taglib uri="/WEB-INF/fmt.tld" prefix="fmt" %>
<%@ taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c" %>

<%--
Tato značka je definována přímo specifikací JSP. Umožňuje asociovat do stránky komponentu, ke
které je možné následně přistupovat v rámci jsp stránky.
id - jméno komponenty pod kterým jí je možné využívat
class - třída implementující komponentu
scope - prostor viditelnosti

Pokud tato značka obsahuje tělo, pak je toto tělo provedeno jen v případě vytvoření komponenty v daném kontextu.
To nám zajišťuje v tomto případě inicializaci kolekce jen jednou.
--%>
<jsp:useBean id="uzivatele" class="cviceni6.SeznamUzivatelu" scope="session">
<%
   uzivatele.uloz(new Uzivatel("wal314", "Johnny",  "Walker"));
   uzivatele.uloz(new Uzivatel("bon007", "James",   "Bond"));
   uzivatele.uloz(new Uzivatel("gat032", "William", "Gates"));
   uzivatele.uloz(new Uzivatel("gel20", "Yveta", "Geletičová"));
   uzivatele.uloz(new Uzivatel("nav083", "Lumír", "Návrat"));
   uzivatele.uloz(new Uzivatel("ben64", "Miroslav", "Beneš"));
%>
</jsp:useBean>
<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.1//EN"
    "http://www.w3.org/TR/xhtml11/DTD/xhtml11.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="cs">
  <head>
    <meta http-equiv="Content-Type" content="application/xhtml+xml; charset=utf-8" />
    <meta name="Keywords" content="" />
    <meta name="Author" content="Lumír Návrat" />
    <title>Java Standard Tag Library</title>
  </head>
  <body>
  <h2>JSTL 1</h2>
  <c:out value="Toto je pokusny text" />
  <table border="1">
  <%--
    Značka forEach je základní značkou pro procházení kolekce prvků. Pomocí této značky
    je možné ale rovněž procházet skrz rozsah indexů jako v klasickém cyklu for.

    var - jméno proměnné ve kterém je uložena aktuální hodnota cyklu.
    varStatus - proměnná, se stavovými informacemi cyklu, jako je informace o počtu prvků,
                zda se jedná o první prvek nebo poslední apod.
    items - kolekce, kterou chcem procházet.

    begin  - počáteční index
    end    - koncový index
    step   - krok
    Podobná je značka forTokens.
  --%>
  <c:forEach var="uziv" varStatus="st" items="${uzivatele.seznam}" >
    <%--
    Značka pro podmíněné vykonávání kódu.

    test - podmínka, která se má otestovat a na jejímž základě se provede tělo značky.
           Lze testovat např na prázdnou proměnnou či naopak (empty, not empty).
    --%>
    <c:if test="${uziv.login == 'nav083'}">
      <%--
      Značka umožňuje nastavit hodnotu nějaké proměnné

      value - hodnota
      var - proměnná, kterou chceme nastavit
      --%>
      <c:set target="${uziv}" property="role" value="doktorand" />
    </c:if>

    <%--
    Značka nabízející funkcionalitu podobnou příkazu switch.
    V rámci těla naleznete několik značkek <c:when> a volitelná jedna
    značka <c:otherwise>, které mají stejný význam jako značka <c:if>
    --%>
    <c:choose>
        <c:when test="${uziv.login == 'ben64'}">
          <c:set target="${uziv}" property="role" value="vedoucí" />
        </c:when>
        <c:when test="${uziv.login == 'gel20'}">
          <c:set target="${uziv}" property="role" value="tajemník" />
        </c:when>
        <c:when test="${uziv.login == 'nav083'}">
          <c:set target="${uziv}" property="role" value="${uziv.role}, cvičící" />
        </c:when>
        <c:otherwise>
         <c:set target="${uziv}" property="role" value="student" />
        </c:otherwise>
    </c:choose>
  <tr>
    <%--
    Značka pro výpis do stránky

    value - hodnota, kterou chceme vypsat
    --%>
    <td><c:out value="${st.count}"/></td>
    <td>${uziv.login}</td>
    <td>${uziv.jmeno} ${uziv.prijmeni}</td>
    <td>${uziv.role}
    </td>
  </tr>
  </c:forEach>
  </table>

  <%--
  Značka pro vygenerování URL adresy. Oproti přímému zápisu má výhodu v tom,
  že pokud prohlížeč má vypnuté cookies, tak se do URL vloží ID session.

  V tělě se mohou objevit parametry pro metodu GET.
  --%>
  <c:url var="url" value="priklad2.jsp">
    <c:param name="arg1" value="4"/>
    <c:param name="arg2" value="hodnota druhého argumentu"/>
  </c:url>
  Pokračujte na stránku <a href='${url}'>priklad2.jsp</a>
  </body>
</html>
